#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float grayscaleFactor;

void main(void)                                                             
{
    vec4 color = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);   
    float luminance =  0.2126*color.r + 0.7152*color.g + 0.0722*color.b;
    vec4 colorLerp  = mix(color, vec4(luminance, luminance, luminance, color.a), grayscaleFactor);
    gl_FragColor = colorLerp;
}
