#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec4 HSV;
uniform sampler2D color_map_tex;

vec4 shiftColor(vec4,vec4);

void main(void)
{
    vec4 grayScaleValue = texture2D(CC_Texture0, v_texCoord);
    vec4 color = texture2D(color_map_tex, vec2(grayScaleValue.r, 0));
    vec4 result = shiftColor(color, HSV);
    gl_FragColor.a = alpha;
    gl_FragColor.rgb = vec3(result.r * alpha, result.g * alpha, result.b * alpha);
}

vec4 shiftColor(vec4 rgbOriginal, vec4 hsvShift)
{
    vec4 result = vec4(rgbOriginal.x, rgbOriginal.y, rgbOriginal.z, rgbOriginal.w);
    float VSU = hsvShift.z * hsvShift.y * cos(hsvShift.x * 3.14159265 * 2.0);
    float VSW = hsvShift.z * hsvShift.y * sin(hsvShift.x * 3.14159265 * 2.0);
                   
    result.x = (.299*hsvShift.z+.701*VSU+.168*VSW)*rgbOriginal.x
                            + (.587*hsvShift.z-.587*VSU+.330*VSW)*rgbOriginal.y
                            + (.114*hsvShift.z-.114*VSU-.497*VSW)*rgbOriginal.z;
                   
    result.y = (.299*hsvShift.z-.299*VSU-.328*VSW)*rgbOriginal.x
                            + (.587*hsvShift.z+.413*VSU+.035*VSW)*rgbOriginal.y
                            + (.114*hsvShift.z-.114*VSU+.292*VSW)*rgbOriginal.z;
                   
    result.z = (.299*hsvShift.z-.3*VSU+1.25*VSW)*rgbOriginal.x
                            + (.587*hsvShift.z-.588*VSU-1.05*VSW)*rgbOriginal.y
                            + (.114*hsvShift.z+.886*VSU-.203*VSW)*rgbOriginal.z;
    result.w = rgbOriginal.w;
    return result;
}
