#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform sampler2D color_map_tex;

void main(void)
{
    vec4 grayScaleValue = texture2D(CC_Texture0, v_texCoord);
    vec4 result = texture2D(color_map_tex, vec2(grayScaleValue.r, 0));
    
    float alpha = grayScaleValue.a * v_fragmentColor.a;
    gl_FragColor.a = alpha;
    gl_FragColor.rgb = vec3(result.r * alpha, result.g * alpha, result.b * alpha);
}
